/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

/*
 * pasis_types.h
 *
 *   Header file that contains all the standard types for use in PASIS.
 *   Derive all other types from these!
 *
 */

#ifndef __PASIS_TYPES_H__
#define __PASIS_TYPES_H__

#include "pasis_config.h"

///byte value
typedef u_int8_t p_byte;
///8 bit signed value
typedef int8_t p_int8;
///8 bit unsigned value
typedef u_int8_t p_uint8;
///16 bit signed value
typedef int16_t p_int16;
///16 bit unsigned value
typedef u_int16_t p_uint16;
///32 bit signed value
typedef int32_t p_int32;
///32 bit unsigned value
typedef u_int32_t p_uint32;
///64 bit signed value
typedef int64_t p_int64;
///64 bit unsigned value
typedef u_int64_t p_uint64;

#endif /* !__PASIS_TYPES_H__ */
