

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <krb5.h>
#include <com_err.h>

#include "krb_box.h"
#include "st.h"
#include <stdlib.h>
#include <arpa/inet.h>



int
main(int argc, char* argv[])
{

    char my_hostname[MAXHOSTNAMELEN];
    struct hostent *host = NULL;
    u_int cli_addr, srv_addr;
    extern int opterr, optind;
    extern char * optarg;
    int	ch;


    char *hostname = 0;
    char *progname = 0;
    char* principal = NULL;
    octet_string *ret_key;
    int i;
   

    progname = argv[0];

    /*
     * Parse command line arguments
     *  
     */
    opterr = 0;
    while ((ch = getopt(argc, argv, "p:h:")) != -1)
    switch (ch) {
    case 'p':
	principal = optarg;
	break;
    case 'h':
	hostname = optarg;
	break;
    default:
	exit(1);
	break;
    }
    argc -= optind;
    argv += optind;
    if (argc > 0) {
      exit(1);
    }

    if (hostname == 0) {
	fprintf(stderr, "You must specify a hostname to contact.\n\n");
	exit(1);
    }

    if (gethostname(my_hostname, sizeof(my_hostname)) < 0) {
	perror("gethostname");
	exit(1);
    }
    
    st_init();

    host = gethostbyname(my_hostname);
    cli_addr = ((struct in_addr*)host->h_addr)->s_addr;
    host = gethostbyname(hostname);
    srv_addr = ((struct in_addr*)host->h_addr)->s_addr;

    krb_init_keycache_cli();
    ret_key = krb_get_sh_key_cli(principal, cli_addr, srv_addr);
    if (ret_key == NULL)
      printf("WERT\n");
    else {
      for (i = 0; i<ret_key->length; i++)
	printf("%02x", ((unsigned char*)ret_key->data)[i]);
      printf("\n");
    }

    while(1) 
        st_sleep(1);

    return 0;
}

/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */
