/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASISIO_INTERNAL_H__
#define __PASISIO_INTERNAL_H__

#include "pasis_config.h"
#include "pasis_types.h"
#include "pasis_lists.h"

#include "pasisio.h"

#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif

struct pasisio_select_s;

/** Top level request structure per share block */
typedef struct pasisio_request_s {
    int                       id;      /* Debugging only */

    p_uid_t                   uid;
    /*pasisio_fid_t            *fid;*/

    p_uint32                  block_size;
    p_uint64                  block_num;
    p_byte                   *block_data;

    unsigned int              share_successes;

    struct pasisio_select_s  *drive_select;

    void                     *proto_data;

} pasisio_request_t;

#ifdef __cplusplus
}
#endif

#endif /* __PASISIO_INTERNAL_H__ */

/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */ 
