/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASIS_MD_DIR_H__
#define __PASIS_MD_DIR_H__

/* Separate structures from prototypes to simplify compilation of md_fs */

#include "pasis_config.h"
#include "pasis_types.h"

#include "pasis_md_prot.h"

#define PASIS_MD_DIR_BLK_SIZE     4096
#define PASIS_MD_DIR_BLK_SHIFT    12

typedef struct pasis_md_dir_hdr_s {
    p_uint32 free_offset;
} pasis_md_dir_hdr_t;


/* Directory entry -- followed by variable length name */
typedef struct pasis_md_dir_entry_s {
    p_uint32        name_len;
    p_uint32        fileid;
    pasis_md_fid_t  fid;
    // The partition number is used for testing. A server can pretend to be
    // multiple servers, by using the incoming partition number as its node ID.
    p_uint32        partition;
} pasis_md_dir_entry_t;


#define PASIS_MD_DIR_HDR_SIZE (sizeof (pasis_md_dir_hdr_t))
#define PASIS_MD_DIR_ENT_SIZE (sizeof (pasis_md_dir_entry_t))

                          
#endif


/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */
