/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASIS_MD_FID_LOCK_H__
#define __PASIS_MD_FID_LOCK_H__

#include "pasis_config.h"
#include "pasis_types.h"

#include "pasis_md_prot.h"


class MDVersionedObject;


void pasis_md_fid_lock_stats_init (void);
void pasis_md_fid_lock_stats_dump (int shutdown_flag);

int
pasis_md_fid_lock_init (int order_operations_flag);

void
pasis_md_fid_lock_shutdown (void);



/* Lock N objects.  Objects are sorted first, on OID, so we can do 2 phase
 * locking, and avoid deadlocks. */
void
pasis_md_fid_lock (p_uint32            n,
                   MDVersionedObject **objects);

void
pasis_md_fid_unlock (p_uint32            n,
                     MDVersionedObject **objects);



#endif /* __PASIS_MD_FID_LOCK_H__ */
