#!/usr/bin/perl

# The PASIS Query/Update Project
# Copyright (c) 2007, Carnegie Mellon University.
# All rights reserved.
# http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
#
# This software is being provided by the copyright holders under the
# following license. By obtaining, using and/or copying this software,
# you agree that you have read, understood, and will comply with the
# following terms and conditions:
#
# Permission to reproduce, use, and prepare derivative works of this
# software is granted provided the copyright and "No Warranty" statements
# are included with all reproductions and derivative works and associated
# documentation. This software may also be redistributed without charge
# provided that the copyright and "No Warranty" statements are included
# in all redistributions.
#
# NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
# CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
# EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
# TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
# OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
# MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
# TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
# COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
# OR DOCUMENTATION.


    my $total_tps = 0;
    my $total_response_time = 0;
    my $count = 0;

    while (<*_0_cmd.out>) {
        my $filename = $_;
        $tps = `grep "Total Throughput" $filename`;
        $tps =~ /([.\d]+) req\/s/;
        $tps = $1;
        $total_tps += $tps;

        $rt = `grep "Measurement:" $filename`;
        $rt =~ /mean=([.\d]+)ms/;
        $rt = $1;
        $total_response_time += $rt;

        ++$count;
    }

    print "Average mean response time: ", $total_response_time / $count, "\n";
    print "Total throughput: $total_tps req/s\n";
